#!/bin/sh
# $Id: laps.sh,v 1.6 2004/05/11 12:59:18 rico Exp $
usage='usage: laps {[-align files] [-widths "1 2 3..."] \
[-utag files] [-tag files] [-htag files] [-vtag files] \
[-dot opts...] [-a2d opts...]}'

#case $# in 
#0) echo $usage 2>&1; exit 1;;
#esac

PATH=$PATH:/depot/align/bin
cur=alignfiles

while 
  case $# in
  0) false;;
  *) true;;
  esac
do
  case $1 in
  -w*) cur=widths;;
  -utag) cur=utagfiles;; 
  -tag) cur=tagfiles;; 
  -htag) cur=htagfiles;; 
  -vtag) cur=vtagfiles;; 
  -align) cur=alignfiles;;
  -dot) cur=dotopts;;
  -a2d) cur=a2dopts;;
  *) tmp=$cur; eval $cur=\"\$${tmp} $1\";;
  esac
  shift
done

doalignfiles()
{
  linewidth=1
  for a in $alignfiles
  do 
    echo "% align: $@: '$a'"
    align2dot $@ -w $linewidth $a2dopts <$a
    case $widths in
      '') linewidth=`expr $linewidth + 2`;;
      *)  shift; linewidth=$1;;
    esac
  done 
}

set -- $widths
{ doalignfiles -h
  [ x"$utagfiles" = "x" ] || 
        (echo "% utagfiles: '$utagfiles'"; echo plotdata; cat $utagfiles)
  doalignfiles
  [ x"$tagfiles" = "x" ] || (echo "% tagfiles: '$tagfiles'"; 
				cat $tagfiles)
  [ x"$htagfiles" = "x" ] || (echo "% htags: '$htagfiles'"; 
				echo 'horizontal' ; cat $htagfiles)
  [ x"$vtagfiles" = "x" ] || (echo "% vtags: '$vtagfiles'";
				echo 'vertical' ; cat $vtagfiles)
} | dotplot -creator=laps $dotopts

