#!/bin/sh
# $Id: pmps.sh,v 1.4 2004/05/11 12:59:18 rico Exp $

usage() {
 echo 'usage: [-x "x0 x1"]'  1>&2
 echo '       [-y n] [-width n]' 1>&2
 echo '       [{-utag|-tag|-htag|-vtag|-align} "files"]' 1>&2
 echo '       [{-dot|-a2d} opts]' 1>&2
 echo '       [-procset]' 1>&2
 exit 1
}

utagfiles=''
tagfiles=''
htagfiles=''
vtagfiles=''
alignfiles=''
W=''

cur=alignfiles

while 
  case $# in
  0) false;;
  *) true;;
  esac
do
  case $1 in
  -procset) dotplot -procset; exit 0;;
  -[Ww]*) cur=W;;
  -Y*) cur=Y;;
  -X*) cur=X;;
  -ytrans) cur=Y;;
  -xtrans) cur=X;;
  -tag) cur=tagfiles;; 
  -htag) cur=htagfiles;; 
  -utag) cur=utagfiles;; 
  -vtag) cur=vtagfiles;; 
  -align) cur=alignfiles;;
  -dot) cur=dotopts;;
  -a2d) cur=a2dopts;;
  *) tmp=$cur; eval $cur=\"\$${tmp} $1\";;
  esac
  shift
done

case "$W" in
'') W=2;;
*) set -- $W; W=$1;;
esac

case "$alignfiles" in
'') alignfiles='-';;
esac

case "$X" in
'') X0=-1; X1=-1;;
*) set -- $X; X0=$1; X1=$2;;
esac

set -- $Y; Y=$1

{
  for a in $alignfiles
  do 
    echo "% headers: '$a'"
    echo "% align2pm -h -W $W -x $X0 -X $X1 -Y $Y $a"
    align2pm -h -W $W -x $X0 -X $X1 -Y $Y $a
  done 
  [ x"$utagfiles" = "x" ] || 
	(echo "% utagfiles: '$utagfiles'"; cat $utagfiles)
  for a in $alignfiles
  do 
    echo "% align: '$a'"
    align2pm -a -W $W -x $X0 -X $X1 -Y $Y $a
  done 
  [ x"$tagfiles" = "x" ] || 
	(echo "% tagfiles: '$tagfiles'"; cat $tagfiles)
  [ x"$htagfiles" = "x" ] || 
	(echo "% htags: '$htagfiles'"; echo 'horizontal' ; cat $htagfiles)
  [ x"$vtagfiles" = "x" ] || 
	(echo "% vtags: '$vtagfiles'"; echo 'vertical' ; cat $vtagfiles)
} | dotplot -creator=pmps $dotopts
