/* slice.c -- print a range of columns from a "refine" output, as indexed by
positions in the reference sequence.
*/

#include "util.h"
#include "read_malign.h"

int main( int argc, char **argv)
{
	int f, t, from, to, i, j, k, nrow, ncol;
	char **seq_name, **A, x;

	argv0 = "slice";
	if (argc != 4)
	fatal("args: MultiPipMaker-text-alignment from to");

	A = read_malign(argv[1], &nrow, &ncol, &seq_name);
	f = atoi(argv[2]);
	t = atoi(argv[3]);
	if (f <= 0 || t <= 0)
		fatal("incorrect sequence positions");
	if (f > t)
		fatal("endpoints given in wrong order.");

	from = to = -1;
	for (j = k = 0; j < ncol; ++j)
		if (isalpha(A[0][j])) {
			if (++k == f)
				from = j;
			if (k == t){
				to = j;
				break;
			}
		}
	if (j >= ncol)
		fatal("positions too large for alignment");

	for (i = 0; i < nrow; ++i) {
		for (j = from; j <= to; ++j) {
			x = A[i][j];
			if (i > 0 && x == A[0][j])
				x = '.';
			putchar(x);
		}
		printf("  %s\n", seq_name[i]);
	}
	
	return 0;
}
