/*
* dotprep.c - prepare a blastz output file for making a dotplot.
*
* The needed operations are (1) replace the stated length of sequence 2 by the
* sum of the lengths for all contigs in sequence 2, (2) identify all alignments
* to a reverse complement and modify associated diagonal lines so they run
* upper-left to lower-right, and (3) stack the dotplots for the contigs one on
* top of the other.
*/

#include "util.h"
#include "seq.h"
#include "lav.h"

enum {
  BUF_SIZE=500
};

int main(int argc, char **argv)
{
	FILE *fp;
	int P1, L2, P1old, L2old, offset;
	char buf[BUF_SIZE], name[BUF_SIZE];
	int nth, nth_old, rc;

	argv0 = "dothoriz";
	if (argc != 2)
		fatal("arg = blastz-output");

	fp = alignopen(argv[1]);
	nth_old = P1old = L2old = offset = 0;
	printf("plotdata\n");
	buf[0] = '\0';
	while (lav_seqname4(2, fp, buf, BUF_SIZE, name, &P1, &L2, &rc, &nth)) {
		if (nth != nth_old) {
			offset += L2old;
			if (offset > 0)
			       printf("%d HRule\n", offset);
		}
		P1old = P1;
		L2old = L2;
		nth_old = nth;
	}
	fclose(fp);
	return 0;
}
