#!/bin/sh
# the next line restarts using tclsh \
exec tclsh "$0" "$@"

# '$Id: dompip.sh,v 1.3 2003/03/25 01:49:38 schwartz Exp schwartz $'

set PIPLIB "$env(PIPHOME)/lib"
set PIP_EMAIL_LIMIT [expr 4*1024*1024]

# files:
# seq*data seq*name
# seq1mask exons colors
# id dump

# values:
set f [open ./email]
set TO [read $f]
close $f
regsub -all "\[ \a\b\t\n\r\f\v\]+" $TO "" TO

proc output_too_big {} {
    set t 0
    foreach f [glob pip.ps pip.pdf align.ps align.pdf align.txt] {
	incr t [file size $f]
    }
    return [expr $t > $PIP_EMAIL_LIMIT]
}

proc force_www {} {
    if [file isfile $PIPHOME/etc/forcewww] {
	set f [open $PIPHOME/etc/forcewww]
	set line ""
	while {[gets $f line] >= 0} {
	    if {[string compare $f $TO] == 0} {
		return 1
	    }
	}
	close $f
    }
    return 0
}

proc want_www {} {
    return [catch {exec f.bool genwww}]
}

proc cons_result args {
    if { [want_www] || [force_www] || [output_too_big] } {
	eval exec mpm-html $args >@stdout 2>@stderr
    } else {
	eval exec mpm-mime $args >@stdout 2>@stderr
    }
}

if {[string length $TO] <= 0} {puts stderr "Empty email address"; exit 1;}
puts stderr "To: $TO"
puts stderr {From: MultiPipMaker <pipmaster@bio.cse.psu.edu>}
puts stderr {Subject: Unrecoverable errors from MultiPipMaker (submission failed)}
puts stderr ""

# --- main

set msg ""
set status [catch {
  exec mpm-run >@stdout 2>@stderr
  cons_result \
   --to "$TO" \
   --pipps pip.ps \
   --pippdf pip.pdf \
   --acgtps align.ps \
   --acgtpdf align.pdf \
   --acgttxt align.txt \
   --args dump
} msg]

if $status {
    puts stderr "status: $status"
    puts stderr "error: $errorCode"
    puts stderr "msg: $msg"
}

set f [open status w]
puts $f "$status"
close $f
exit $status
